% simulator
%

clear all;
%RandStream.setDefaultStream(RandStream('mt19937ar','seed',sum(100*clock)))
%;
% Get the simulation parameters
sim_para = paras_sim;
path_para = paras_path(sim_para);
iterations =1;

  noncooper=0;
for jj=1:iterations
fprintf('iteration %i\n',jj);

%Get cells and SUs
position = get_positionBS(sim_para,path_para,1);

%Get PUs
position = get_position(sim_para,path_para,1,position);

%Get thetas of channels and assign PUs to BSs (now its random)
theta=rand(1,sim_para.K);
totalcells=(sim_para.boundaryx/sim_para.cellwidth)*sim_para.lines;



for gg=1:totalcells

numknown=sim_para.known;
knownchans{gg} = zeros(1,numknown);
for ss=1:numknown
    tempchan=0;
    finished=0;
    
    while (~finished)
tempchan=    ceil(sim_para.K.*rand(1));
if (sum(ismember(knownchans{gg},tempchan) >0))
    finished=0;
else
    finished=1;
end
    end
knownchans{gg}(ss)=[tempchan];
end

end



[fades] = get_a(sim_para,0);
%%%%Noncoop
[partition,noncoop{jj},history,currentcoal] = initiate(sim_para,path_para,theta,knownchans,position,fades);

%%
[partition,currentcoal,history,counter,switchoperations] = coalform(sim_para,path_para,partition,currentcoal,history,theta,knownchans,position,fades);
totutil=0;
for ll=1:size(partition.members,2)
    totutil=totutil+sum(partition.utility{ll});
end
avutil(jj)=totutil/totalcells;


coalsize(jj)=totalcells/size(partition.members,2);
partsav{jj}=partition;
avnoncoop(jj)=mean(noncoop{jj});

end
