function position = get_position(sim_para,path_para,random,position); %#ok<NOSEM>
lowerboundaryx=-sim_para.boundaryx/2;
cellsperline=sim_para.boundaryx/sim_para.cellwidth;

totalcells=cellsperline*sim_para.lines;
totallines=ceil(totalcells/cellsperline);
lowerboundaryy=-totallines/2;
if (random >= 1)

 for j = 1:sim_para.K

 %randomly generate 
position.pu(j) = (lowerboundaryx+ (lowerboundaryx+sim_para.boundaryx-lowerboundaryx)*rand(1))  +i*(lowerboundaryy + (lowerboundaryy+totallines-lowerboundaryy)*rand(1)) ;

squarething=position.pu(j)-sim_para.maxr/2-i*sim_para.maxr/2;
lowrecx=real(squarething);
lowrecy=imag(squarething);

if (lowrecx < lowerboundaryx)
    lowrecx=lowerboundaryx;
end
if (lowrecy < lowerboundaryy)
    lowrecy=lowerboundaryy;
end
stepx=sim_para.maxr;
stepy=sim_para.maxr;
if (lowrecx+sim_para.maxr > -lowerboundaryx)
    stepx=-lowerboundaryx-lowrecx;
end
if (lowrecy+sim_para.maxr > -lowerboundaryy)
    stepy=-lowerboundaryy-lowrecy;
end



position.pur(j)= (lowrecx+ stepx*rand(1))  +i*(lowrecy + stepy*rand(1)) ;

R=abs(position.pu(j) - position.pur(j));

    while ( (R < path_para.d0) || (size(find(position.pur ==position.pur(j) ),2) >1) )
position.pur(j)= (lowerboundaryx+ (lowerboundaryx+sim_para.boundaryx-lowerboundaryx)*rand(1))  +i*(lowerboundaryy + (lowerboundaryy+totallines-lowerboundaryy)*rand(1)) ;

   end%end while
 end
 
 
 
else %for fixed positions /testing
 position.su=[0.1 + 1i];


end
