function position = get_positionBS(sim_para,path_para,random); %#ok<NOSEM>

cellsperline=sim_para.boundaryx/sim_para.cellwidth;

totalcells=cellsperline*sim_para.lines;
totallines=ceil(totalcells/cellsperline);%used in case cell is less than 1 km
lowerboundaryy=-totallines/2;
lowerboundaryx=-sim_para.boundaryx/2;
for kk=1:totalcells
   %%%Find line of the cell 
    lineofthiscell=ceil(kk/cellsperline);
    
    %%Find location in line
            startofthisline=1;
    if (lineofthiscell > 1)

       for jj=1:(lineofthiscell-1)
        startofthisline=startofthisline+cellsperline;
       end
    end
    cellindex=kk-startofthisline+1;
    
    

    
    cellx=lowerboundaryx+cellindex-1;
    celly=lowerboundaryy+lineofthiscell-1;

    position.BS(kk) = (cellx+cellx+1)/2 + (celly+celly+1)/2*i;

    fprintf('Cell number %i is the %i on line %i,lower x %f\n',kk,cellindex,lineofthiscell,cellx);    
    
    %%%% %randomly generate sus within cell of kk
    for j=1:sim_para.supercell
    position.su(j,kk) = (cellx + (cellx+1-cellx)*rand(1))  +i*(celly + (celly+1-celly)*rand(1)) ;
    R=abs(position.su(j) - position.BS(kk));
    while ( (R < path_para.d0) || (size(find(position.su ==position.su(j) ),2) >1) )
    position.su(j) = (cellx + (cellx+1-cellx)*rand(1))  +i*(celly + (celly+1-celly)*rand(1)) ;
    end%end while
    end
 end
 
    
end
