function [utility,chans] = get_utility(sim_para,path_para,coalition,knownchans,theta,position,fades); %#ok<NOSEM>
for mm=1:size(coalition,2)
    chans(:,mm)=knownchans{coalition(mm)}';
end
utility=zeros(1,size(coalition,2));
Pf = ginc(sim_para.u,sim_para.lambda/2)/gamma(sim_para.u); %Pf is the same for all
facomp=1-Pf;

for kk=1:size(coalition,2)
curBS = coalition(kk);
susserved=position.su(:,coalition(kk));
termPU=[];
    for cc=1:size(knownchans{curBS},2)
        curPU = knownchans{curBS}(cc);
        term=zeros(1,size(susserved,1));
       for ll=1:size(susserved,1)
        curSU=susserved(ll);
        %%Get proba success while PU is abset (Positive term)
        chan=get_channel(sim_para,path_para,curSU,position.BS(curBS));
 
        SNR=sim_para.Pmax*chan^2*fades.SUdestchan(curBS,ll)/sim_para.noise;
        proba=exp(-sim_para.target/SNR);
        term(ll)=facomp*proba*theta(curPU);
        
        %GEt negative term
         %%Get missing and PU capacity
         [Pm] = get_pm(sim_para,path_para,position.pu(curPU),position.BS(curBS),fades.BSPUchan(curBS,curPU));
         chan=get_channel(sim_para,path_para,position.pu(curPU),position.pur(curPU));
         SNR=sim_para.PPUmax*chan^2*fades.PUchan(curPU)/sim_para.noise;
         probanoSU=(exp(-sim_para.target/SNR));
         intchan=get_channel(sim_para,path_para,(curSU),position.pur(curPU));       
         SINR=sim_para.PPUmax*chan^2*fades.PUchan(curPU)/(sim_para.noise+intchan^2*fades.SUPUChan(curBS,ll,curPU)*sim_para.Pmax);
         probaBAD=(exp(-sim_para.target/SINR));
         reduction=probanoSU-probaBAD;
         term(ll)=term(ll) - sim_para.alpha*(1-theta(curPU))*reduction*Pm;          
       end%end for ll
       termPU(cc)=sum(term);
    end %end for cc 
    utility(kk)=utility(kk)+sum(termPU);


%trust=[0.5 0.6 0.5 0.89 0.3      0.2];
%%%%Cooperative part
if (size(coalition,2) > 1)
    termPUnew=[];
    termPUchan=[];
    for jj=1:size(coalition,2)
        if (coalition(jj)~=coalition(kk))
         curBSss=position.BS(coalition(jj));
         chansavailable= setdiff(knownchans{coalition(jj)},knownchans{coalition(kk)});
             if (size(chansavailable,2) > 0)
                 for cc=1:size(chansavailable,2)
                     
                     curPU = chansavailable(cc);
                     term=zeros(1,size(susserved,1));
                     for ll=1:size(susserved,1)
                          %%Current SU
                          curSU=susserved(ll);
                           %%Get missing and PU capacity
                           [Pm] = get_pm(sim_para,path_para,position.pu(curPU),curBSss,fades.BSPUchan(coalition(jj),curPU));
                     
                           %%%The trust value
                           PcurBSss=facomp*theta(curPU)+Pm*(1-theta(curPU));
                           [PmcurBS] = get_pm(sim_para,path_para,position.pu(curPU),position.BS(curBS),fades.BSPUchan(coalition(kk),curPU));
                          Pinter=facomp*facomp*theta(curPU)+PmcurBS*Pm*(1-theta(curPU));
                         trust=Pinter/PcurBSss;
                           chantheta=theta(curPU)*trust;

               if ( (chantheta > theta(curPU))||(PcurBSss >1 ) || (Pinter > 1))

                                      error('No way chantheta larger than theta\n');
               end
                  chan=get_channel(sim_para,path_para,curSU,position.BS(curBS));
                   SNR=sim_para.Pmax*chan^2*fades.SUdestchan(coalition(kk),ll)/sim_para.noise;
                  proba=(exp(-sim_para.target/SNR));
                  term(ll)=facomp*proba*chantheta;
               %%GEt negative
                chan=get_channel(sim_para,path_para,position.pu(curPU),position.pur(curPU));
                SNR=sim_para.PPUmax*chan^2*fades.PUchan(curPU)/sim_para.noise;
                probaPU=(exp(-sim_para.target/SNR));
                intchan=get_channel(sim_para,path_para,curSU,position.pur(curPU));       
                SINR=sim_para.PPUmax*chan^2*fades.PUchan(curPU)/(sim_para.noise+intchan^2*fades.SUPUChan(coalition(kk),ll,curPU)*sim_para.Pmax);
                probaPUbad=(exp(-sim_para.target/SINR));       
                reduction=probaPU-probaPUbad;
                 if (reduction < 0)
                               error('capacity reduced with interference\n');
                 end
                 term(ll)=term(ll)-sim_para.alpha*(1-chantheta)*reduction*Pm;
                 end%end for ll

                 termPUnew(jj,chansavailable(cc))=sum(term);  
                                  if (sum(term)==0)
                                                       termPUnew(jj,chansavailable(cc))=0.000001;  
                                  end
                 end%for every channel that is new
             end                %end if channels are existent
        end      
    end%end for jj

    for ss=1:size(termPUnew,2)
        possibilities=termPUnew(:,ss);

        possibilities=possibilities(find(possibilities~=0));
%        termPUchan(ss)=mean(possibilities(find(possibilities~=0)));
if (size(possibilities,1) > 0)
        termPUchan(ss)=max(possibilities);
else
       termPUchan(ss)=0;
end
    end%for ss
        utility(kk)=utility(kk)+sum(termPUchan);
%        utility(kk)
 %       size(coalition,2)
  %      log(size(coalition,2)-1)
   %     pause;
        
%        utility(kk)=utility(kk) + 6*log(1- ( size(coalition,2)/)^2);
        %/(sim_para.pay*(size(coalition,2)-1));
end%end cooperative part


end%end for kk